#!/bin/sh
# Run this to generate all the initial makefiles, etc.
#
#/* $Id: autogen.sh,v 1.2 2003/03/23 19:02:51 vjt Exp $ */
#

test -f configure.in || {
    echo "**Error**: This directory does not look like the top-level directory"
    exit 1
}

#exit on failure 
set -e

echo Running aclocal ...
aclocal

echo Running autoheader ...
autoheader 

echo Running libtoolize ...
libtoolize --automake -c

echo Running automake ...
automake -a --copy 

echo Running autoconf ...
autoconf

echo All done !
