/* Copyright (C) 1992 Darren Reed
 *
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Id: irc-replies.c,v 1.3 2003/03/23 18:10:11 vjt Exp $ */

/*
 * stolen from bahamut/src/s_err.c
 */
#include "sux.h"
#include "numeric.h"

static gchar *replies[] = 
{
    /* 000 */			NULL,
    /* 001 RPL_WELCOME */	NULL,
    /* 002 RPL_YOURHOST */	NULL,
    /* 003 RPL_CREATED */	NULL,
    /* 004 RPL_MYINFO */	NULL,
    /* 005 RPL_PROTOCTL*/       NULL,
    /* 006 */	                NULL,
    /* 007 */	                NULL,
    /* 008 */	                NULL,
    /* 009 */	                NULL,
    /* 010 */	                NULL,
    /* 011 */	                NULL,
    /* 012 */	                NULL,
    /* 013 */	                NULL,
    /* 014 */	                NULL,
    /* 015 */	                NULL,
    /* 016 */	                NULL,
    /* 017 */	                NULL,
    /* 018 */	                NULL,
    /* 019 */	                NULL,
    /* 020 */	                NULL,
    /* 021 */	                NULL,
    /* 022 */	                NULL,
    /* 023 */	                NULL,
    /* 024 */	                NULL,
    /* 025 */	                NULL,
    /* 026 */	                NULL,
    /* 027 */	                NULL,
    /* 028 */	                NULL,
    /* 029 */	                NULL,
    /* 030 */	                NULL,
    /* 031 */	                NULL,
    /* 032 */	                NULL,
    /* 033 */	                NULL,
    /* 034 */	                NULL,
    /* 035 */	                NULL,
    /* 036 */	                NULL,
    /* 037 */	                NULL,
    /* 038 */	                NULL,
    /* 039 */	                NULL,
    /* 040 */	                NULL,
    /* 041 */	                NULL,
    /* 042 */	                NULL,
    /* 043 */	                NULL,
    /* 044 */	                NULL,
    /* 045 */	                NULL,
    /* 046 */	                NULL,
    /* 047 */	                NULL,
    /* 048 */	                NULL,
    /* 049 */	                NULL,
    /* 050 */	                NULL,
    /* 051 */	                NULL,
    /* 052 */	                NULL,
    /* 053 */	                NULL,
    /* 054 */	                NULL,
    /* 055 */	                NULL,
    /* 056 */	                NULL,
    /* 057 */	                NULL,
    /* 058 */	                NULL,
    /* 059 */	                NULL,
    /* 060 */	                NULL,
    /* 061 */	                NULL,
    /* 062 */	                NULL,
    /* 063 */	                NULL,
    /* 064 */	                NULL,
    /* 065 */	                NULL,
    /* 066 */	                NULL,
    /* 067 */	                NULL,
    /* 068 */	                NULL,
    /* 069 */	                NULL,
    /* 070 */	                NULL,
    /* 071 */	                NULL,
    /* 072 */	                NULL,
    /* 073 */	                NULL,
    /* 074 */	                NULL,
    /* 075 */	                NULL,
    /* 076 */	                NULL,
    /* 077 */	                NULL,
    /* 078 */	                NULL,
    /* 079 */	                NULL,
    /* 080 */	                NULL,
    /* 081 */	                NULL,
    /* 082 */	                NULL,
    /* 083 */	                NULL,
    /* 084 */	                NULL,
    /* 085 */	                NULL,
    /* 086 */	                NULL,
    /* 087 */	                NULL,
    /* 088 */	                NULL,
    /* 089 */	                NULL,
    /* 090 */	                NULL,
    /* 091 */	                NULL,
    /* 092 */	                NULL,
    /* 093 */	                NULL,
    /* 094 */	                NULL,
    /* 095 */	                NULL,
    /* 096 */	                NULL,
    /* 097 */	                NULL,
    /* 098 */	                NULL,
    /* 099 */	                NULL,
    /* 100 */	                NULL,
    /* 101 */	                NULL,
    /* 102 */	                NULL,
    /* 103 */	                NULL,
    /* 104 */	                NULL,
    /* 105 */	                NULL,
    /* 106 */	                NULL,
    /* 107 */	                NULL,
    /* 108 */	                NULL,
    /* 109 */	                NULL,
    /* 110 */	                NULL,
    /* 111 */	                NULL,
    /* 112 */	                NULL,
    /* 113 */	                NULL,
    /* 114 */	                NULL,
    /* 115 */	                NULL,
    /* 116 */	                NULL,
    /* 117 */	                NULL,
    /* 118 */	                NULL,
    /* 119 */	                NULL,
    /* 120 */	                NULL,
    /* 121 */	                NULL,
    /* 122 */	                NULL,
    /* 123 */	                NULL,
    /* 124 */	                NULL,
    /* 125 */	                NULL,
    /* 126 */	                NULL,
    /* 127 */	                NULL,
    /* 128 */	                NULL,
    /* 129 */	                NULL,
    /* 130 */	                NULL,
    /* 131 */	                NULL,
    /* 132 */	                NULL,
    /* 133 */	                NULL,
    /* 134 */	                NULL,
    /* 135 */	                NULL,
    /* 136 */	                NULL,
    /* 137 */	                NULL,
    /* 138 */	                NULL,
    /* 139 */	                NULL,
    /* 140 */	                NULL,
    /* 141 */	                NULL,
    /* 142 */	                NULL,
    /* 143 */	                NULL,
    /* 144 */	                NULL,
    /* 145 */	                NULL,
    /* 146 */	                NULL,
    /* 147 */	                NULL,
    /* 148 */	                NULL,
    /* 149 */	                NULL,
    /* 150 */	                NULL,
    /* 151 */	                NULL,
    /* 152 */	                NULL,
    /* 153 */	                NULL,
    /* 154 */	                NULL,
    /* 155 */	                NULL,
    /* 156 */	                NULL,
    /* 157 */	                NULL,
    /* 158 */	                NULL,
    /* 159 */	                NULL,
    /* 160 */	                NULL,
    /* 161 */	                NULL,
    /* 162 */	                NULL,
    /* 163 */	                NULL,
    /* 164 */	                NULL,
    /* 165 */	                NULL,
    /* 166 */	                NULL,
    /* 167 */	                NULL,
    /* 168 */	                NULL,
    /* 169 */	                NULL,
    /* 170 */	                NULL,
    /* 171 */	                NULL,
    /* 172 */	                NULL,
    /* 173 */	                NULL,
    /* 174 */	                NULL,
    /* 175 */	                NULL,
    /* 176 */	                NULL,
    /* 177 */	                NULL,
    /* 178 */	                NULL,
    /* 179 */	                NULL,
    /* 180 */	                NULL,
    /* 181 */	                NULL,
    /* 182 */	                NULL,
    /* 183 */	                NULL,
    /* 184 */	                NULL,
    /* 185 */	                NULL,
    /* 186 */	                NULL,
    /* 187 */	                NULL,
    /* 188 */	                NULL,
    /* 189 */	                NULL,
    /* 190 */	                NULL,
    /* 191 */	                NULL,
    /* 192 */	                NULL,
    /* 193 */	                NULL,
    /* 194 */	                NULL,
    /* 195 */	                NULL,
    /* 196 */	                NULL,
    /* 197 */	                NULL,
    /* 198 */	                NULL,
    /* 199 */	                NULL,
    /* 200 RPL_TRACELINK */	NULL,
    /* 201 RPL_TRACECONNECTING */NULL,
    /* 202 RPL_TRACEHANDSHAKE */NULL,
    /* 203 RPL_TRACEUNKNOWN */	NULL,
    /* 204 RPL_TRACEOPERATOR */	NULL,
    /* 205 RPL_TRACEUSER */	NULL,
    /* 206 RPL_TRACESERVER */	NULL,
    /* 207 */	                NULL,
    /* 208 RPL_TRACENEWTYPE */	NULL,
    /* 209 RPL_TRACECLASS */	NULL,
    /* 210 */	                NULL,
    /* 211 */	                NULL,
    /* 212 RPL_STATSCOMMANDS */	":%s 212 %s %s %u",
    /* 213 RPL_STATSCLINE */	":%s 213 %s C * * %s %s",
    /* 214 RPL_STATSNLINE */	":%s 214 %s N * * %s %s",
    /* 215 RPL_STATSILINE */	":%s 215 %s %c %s * %s %d %d",
    /* 216 RPL_STATSKLINE */	":%s 216 %s %c %s * %s %d :%s",
    /* 217 RPL_STATSQLINE */	":%s 217 %s %c %s * %s %d %d",
    /* 218 RPL_STATSYLINE */	":%s 218 %s %c %d %d %d %d %ld",
    /* 219 RPL_ENDOFSTATS */	":%s 219 %s %c :End of /STATS report.",
    /* 220 */	                NULL,
    /* 221 RPL_UMODEIS */	":%s 221 %s %s",
    /* 222 */			":%s 222 %s %c %s * %s %d %d",
    /* 223 */			":%s 223 %s %c %s * %s %d %d",
    /* 224 */			":%s 224 %s %c %s * %s %d %d",
    /* 225 RPL_STATSZLINE */	":%s 225 %s %c %s %s",
    /* 226 RPL_STATSCOUNT */	":%s 226 %s %s %l",
    /* 227 RPL_STATSGLINE */	":%s 227 %s %c %s * %s %d %d",
    /* 228 */	                NULL,
    /* 229 */	                NULL,
    /* 230 */	                NULL,
    /* 231 */	                NULL,	/* In use by Undernet */
    /* 232 */	                NULL,	/* In use by Undernet */
    /* 233 */	                NULL,	/* In use by Undernet */
    /* 234 */	                NULL,
    /* 235 */	                NULL,
    /* 236 */	                NULL,
    /* 237 */	                NULL,
    /* 238 */	                NULL,
    /* 239 */	                NULL,
    /* 240 */	                NULL,
    /* 241 RPL_STATSLLINE */	":%s 241 %s %c %s * %s %d %d",
    /* 242 RPL_STATSUPTIME */	":%s 242 %s :Services Up %d days, %d:%02d:%02d",
    /* 243 RPL_STATSOLINE */	":%s 243 %s %c %s * %s %lu %d",
    /* 244 RPL_STATSHLINE */	":%s 244 %s %c %s * %s %d %d",
    /* 245 RPL_STATSSLINE */	":%s 245 %s %c %s * %s %d %d",
    /* 246 RPL_STATSULINE */	":%s 246 %s %c %s * %s %d %d",
    /* 247 */	                NULL,		/* Undernet's STATSGLINE */
    /* 248 */	                NULL,		/* Undernet's STATSULINE */
    /* 249 */	                NULL,
    /* 250 */	                NULL,
    /* 251 RPL_LUSERCLIENT */	NULL,
    /* 252 RPL_LUSEROP */	NULL,
    /* 253 RPL_LUSERUNKNOWN */	NULL,
    /* 254 RPL_LUSERCHANNELS */	":%s 254 %s %d :channels formed",
    /* 255 RPL_LUSERME */	NULL,
    /* 256 RPL_ADMINME */	":%s 256 %s :Administrative info about %s",
    /* 257 RPL_ADMINLOC1 */	":%s 257 %s :%s",
    /* 258 RPL_ADMINLOC2 */	":%s 258 %s :%s",
    /* 259 RPL_ADMINEMAIL */	":%s 259 %s :%s",
    /* 260 */	                NULL,
    /* 261 RPL_TRACELOG */	NULL,
    /* 262 */			NULL,
    /* 263 */			NULL,
    /* 264 */			NULL,
    /* 265 RPL_LOCALUSERS */	NULL,
    /* 266 RPL_GLOBALUSERS */	":%s 266 %s :Current users: %d",
    /* 267 */	                NULL,
    /* 268 */	                NULL,
    /* 269 */	                NULL,
    /* 270 */	                NULL,
    /* 271 RPL_SILELIST */      NULL,
    /* 272 RPL_ENDOFSILELIST*/	NULL,
    /* 273 */	                NULL,
    /* 274 */	                NULL,
    /* 275 */			NULL,
    /* 276 */	                NULL,
    /* 277 */	                NULL,
    /* 278 */	                NULL,
    /* 279 */	                NULL,
    /* 280 */	                NULL,	/* In use by Undernet */
    /* 281 */	                NULL,	/* In use by Undernet */
    /* 282 */	                NULL,
    /* 283 */	                NULL,
    /* 284 */	                NULL,
    /* 285 */	                NULL,
    /* 286 */	                NULL,
    /* 287 */	                NULL,
    /* 288 */	                NULL,
    /* 289 */	                NULL,
    /* 290 */	                NULL,
    /* 291 */	                NULL,
    /* 292 */	                NULL,
    /* 293 */	                NULL,
    /* 294 */	                NULL,
    /* 295 */	                NULL,
    /* 296 */	                NULL,
    /* 297 */	                NULL,
    /* 298 */	                NULL,
    /* 299 */	                NULL,
    /* 300 */	                NULL,
    /* 301 RPL_AWAY */		NULL,
    /* 302 RPL_USERHOST */	NULL,
    /* 303 RPL_ISON */		NULL,
    /* 304 */	                NULL,
    /* 305 RPL_UNAWAY */	NULL,
    /* 306 RPL_NOWAWAY */	NULL,
    /* 307 RPL_WHOISREGNICK */	NULL,
    /* 308 RPL_WHOISADMIN */	NULL,
    /* 309 RPL_WHOISSADMIN */	NULL,
    /* 310 RPL_WHOISHELPER */	NULL,
    /* 311 RPL_WHOISUSER */	":%s 311 %s %s %s %s * :%s",
    /* 312 RPL_WHOISSERVER */	":%s 312 %s %s %s :%s",
    /* 313 RPL_WHOISOPERATOR */	NULL,
    /* 314 RPL_WHOWASUSER */	NULL,
    /* 315 RPL_ENDOFWHO */	NULL,
    /* 316 RPL_WHOISCHANOP */	NULL,
    /* 317 RPL_WHOISIDLE */	NULL,
    /* 318 RPL_ENDOFWHOIS */	":%s 318 %s %s :End of /WHOIS list.",
    /* 319 RPL_WHOISCHANNELS */	":%s 319 %s %s :%s",
    /* 320 */	                NULL,
    /* 321 RPL_LISTSTART */	NULL,
    /* 322 RPL_LIST */		NULL,
    /* 323 RPL_LISTEND */	NULL,
    /* 324 RPL_CHANNELMODEIS */	NULL,
    /* 325 RPL_WHOISAGENT */	NULL,
    /* 326 */	                NULL,
    /* 327 */	                NULL,
    /* 328 */	                NULL,
    /* 329 RPL_CREATIONTIME */	NULL,
    /* 330 */	                NULL,
    /* 331 RPL_NOTOPIC */	NULL,
    /* 332 RPL_TOPIC */		NULL,
    /* 333 RPL_TOPICWHOTIME */	NULL,
    /* 334 RPL_COMMANDSYNTAX */	NULL,
    /* 335 */	                NULL,
    /* 336 */	                NULL,
    /* 337 */	                NULL,
    /* 338 */			NULL,
    /* 339 */			NULL,
    /* 340 */	                NULL,
    /* 341 */			NULL,
    /* 342 */ 		 	NULL,
    /* 343 */	                NULL,
    /* 344 */	                NULL,
    /* 345 */	                NULL,
    /* 346 */	                NULL,
    /* 347 */	                NULL,
    /* 348 */	                NULL,
    /* 349 */	                NULL,
    /* 350 */	                NULL,
    /* 351 RPL_VERSION */	":%s 351 %s :%s",
    /* 352 RPL_WHOREPLY */	NULL,
    /* 353 RPL_NAMREPLY */	NULL,
    /* 354 */	                NULL,	/* In use by Undernet */
    /* 355 */	                NULL,
    /* 356 */	                NULL,
    /* 357 */	                NULL,
    /* 358 */	                NULL,
    /* 359 */	                NULL,
    /* 360 */	                NULL,
    /* 361 */	                NULL,
    /* 362 RPL_CLOSING */	NULL,
    /* 363 RPL_CLOSEEND */	NULL,
    /* 364 RPL_LINKS */		NULL,
    /* 365 RPL_ENDOFLINKS */	NULL,
    /* 366 RPL_ENDOFNAMES */	NULL,
    /* 367 RPL_BANLIST */	NULL,
    /* 368 RPL_ENDOFBANLIST */	NULL,
    /* 369 RPL_ENDOFWHOWAS */	NULL,
    /* 370 */	                NULL,
    /* 371 RPL_INFO */		":%s 371 %s :%s",
    /* 372 RPL_MOTD */		":%s 372 %s :- %s",
    /* 373 RPL_INFOSTART */	":%s 373 %s :Server INFO",
    /* 374 RPL_ENDOFINFO */	":%s 374 %s :End of /INFO list.",
    /* 375 RPL_MOTDSTART */	":%s 375 %s :- %s Message of the Day - ",
    /* 376 RPL_ENDOFMOTD */	":%s 376 %s :End of /MOTD command.",
    /* 377 */	                NULL,
    /* 378 */	                NULL,
    /* 379 */	                NULL,
    /* 380 */	                NULL,
    /* 381 RPL_YOUREOPER */	NULL,
    /* 382 RPL_REHASHING */	NULL,
    /* 383 */	                NULL,
    /* 384 RPL_MYPORTIS */	NULL,
    /* 385 */	                NULL,
    /* 386 */	                NULL,
    /* 387 */	                NULL,
    /* 388 */	                NULL,
    /* 389 */	                NULL,
    /* 390 */	                NULL,
    /* 391 RPL_TIME */		":%s 391 %s %s :%s",
    /* 392 */	                NULL,
    /* 393 */	                NULL,
    /* 394 */	                NULL,
    /* 395 */	                NULL,
    /* 396 */	                NULL,
    /* 397 */	                NULL,
    /* 398 */	                NULL,
    /* 399 */	                NULL,
    /* 400 */	                NULL,
    /* 401 ERR_NOSUCHNICK */	":%s 401 %s %s :No such nick/channel",
    /* 402 ERR_NOSUCHSERVER */	NULL,
    /* 403 ERR_NOSUCHCHANNEL */	NULL,
    /* 404 ERR_CANNOTSENDTOCHAN */NULL,
    /* 405 ERR_TOOMANYCHANNELS */NULL,
    /* 406 ERR_WASNOSUCHNICK */	NULL,
    /* 407 ERR_TOOMANYTARGETS */NULL,
    /* 408 ERR_NOCOLORSONCHAN */NULL,
    /* 409 ERR_NOORIGIN */	NULL,
    /* 410 */	                NULL,
    /* 411 ERR_NORECIPIENT */	NULL,
    /* 412 ERR_NOTEXTOSEND */	NULL,
    /* 413 ERR_NOTOPLEVEL */	NULL,
    /* 414 ERR_WILDTOPLEVEL */	NULL,
    /* 415 */	                NULL,
    /* 416 */	                NULL,	/* In use by Undernet */
    /* 417 */	                NULL,
    /* 418 */	                NULL,
    /* 419 */	                NULL,
    /* 420 */	                NULL,
    /* 421 ERR_UNKNOWNCOMMAND */NULL,
    /* 422 ERR_NOMOTD */	":%s 422 %s :MOTD File is missing",
    /* 423 ERR_NOADMININFO */	":%s 423 %s %s :No administrative info available",
    /* 424 ERR_FILEERROR */	NULL,
    /* 425 */	                NULL,
    /* 426 */	                NULL,
    /* 427 */	                NULL,
    /* 428 */	                NULL,
    /* 429 ERR_TOOMANYAWAY */	NULL,
    /* 430 */	                NULL,
    /* 431 ERR_NONICKNAMEGIVEN */	NULL,
    /* 432 ERR_ERRONEOUSNICKNAME */     NULL,
    /* 433 ERR_NICKNAMEINUSE */	NULL,
    /* 434 */	                NULL,
    /* 435 ERR_BANONCHAN */     NULL,
    /* 436 ERR_NICKCOLLISION */	":%s 436 %s %s :Nickname collision KILL",
};

G_INLINE_FUNC gchar *rpl_str(gint numeric)
{
    if(G_UNLIKELY((numeric<0 || numeric>436) || !replies[numeric]))
	return(":%s 999 %s Numeric error! yikes!");
    else
	return(replies[numeric]);
}
